/*
  Prolog code generator class.

  (c) Gertjan van Noord 1997
  based on work by Matt Phillips.
*/

#ifndef _PROLOG_CODE_GENERATOR_H
#define _PROLOG_CODE_GENERATOR_H

#include <iostream.h>
#include <foo/FooObject.h>
#include <CodeFrags.h>


class PrologCodeGenerator
{
public:

  PrologCodeGenerator (const FooObject &s, istream &cf,
		       ostream &b, int option_c, 
		       int option_u, int option_l);

  int nErrors () const {return errors;};


protected:

  const FooObject &scandef;
  CodeFrags codefrags;
  ostream &body;
  string errorProduction;
  int errors;
  int option_compact_code;
  int option_use_module;
  int option_lookahead;

  void doStart (const string &scannerName);
  void doEdgeLists ();
  void doStates ();
  void doEdgeList (const FooObject::Objects &edges,
		   const string &stateNo);
  void doProdBodies (const string &scannerName);
};

#endif
