/*
  $Id: checks.h,v 1.2 1997/05/18 14:38:49 matt Exp $

  Warn and abort macros.
  
  (c) Sep 19th 1995 Matt Phillips.
  */

#ifndef _CHECKS_H
#define _CHECKS_H

void _chkfail (const char *file, int line, int abrt, const char *msg);

#ifdef NCHECK
#  define WARN(exp,msg)
#else
#  define WARN(exp,msg) ((exp) ? (void)0 : _chkfail(__FILE__, __LINE__, 0, msg))
#endif

#ifdef NCHECK
#  define WARNS(exp)
#else
#  define WARNS(exp,msg) ((exp) ? (void)0 : _chkfail(__FILE__, __LINE__, 0, #exp))
#endif

#ifdef NCHECK
#  define CHECK(exp,msg)
#else
#  define CHECK(exp,msg) ((exp) ? (void)0 : _chkfail(__FILE__, __LINE__, 1, msg))
#endif

#ifdef NCHECK
#  define CHECKS(exp)
#else
#  define CHECKS(exp) ((exp) ? (void)0 : _chkfail(__FILE__, __LINE__, 1, #exp))
#endif

#ifdef NCHECK
#  define REPORT(m)
#else
#  define REPORT(m) (_chkfail(__FILE__, __LINE__, 0, m))
#endif

#define ABORT(m) (_chkfail(__FILE__, __LINE__, 1, m))

#endif
