/*
  $Id: strhash.cpp,v 1.1 1996/05/19 00:54:15 matt Exp $

  Hash function for C++ strings.

  (c) Matt Phillips 1996.
  */

#include "strhash.h"

#define PRIME 211

int hash (const string &str)
{
  unsigned h = 0, g;
  
  for (unsigned char *p = (unsigned char *)str.c_str (); *p; p++)
  {
    h = (h << 4) + (*p);
    if (g = (h & 0xf0000000))
    {
      h = h ^ (g >> 24);
      h = h ^ g;
    }
  }
  
  return h % PRIME;
}
